def __import(self, do_it):
        if not do_it:
            return True
        do_it = False
        config_file = resource.user_resource_file('midi_illuminator','Tau Midi Light Controller.csv')
        csvImporter = csv.reader(open(config_file, 'rb'), delimiter=',', quotechar='"')
        class table_types:
            parent_to_child=1
            multiply_numbers=2
            concatenate_strings=3
        class states:
            read_parent_to_child_table=table_types.parent_to_child
            read_multiply_numbers_table=table_types.multiply_numbers
            read_concatenate_strings_table=table_types.concatenate_strings
            read_table_header=4
            read_single_parameter=5
            search=6
        class table:
            slot_num
            offset
            type
            row_headings
            col_heading
        current_tables = []
        state = states.read_parameter_name
        curr_row = 0
        curr_col = 0
        curr_table = nil
        curr_single_parameter = nil
        for row in csvImporter:
            if curr_col <> csvImporter.line_num:
                curr_row = 0
                curr_col = csvImporter.line_num
            curr_col = curr_col + 1
            if row.startswith('#'):
                pass
            if state == states.search:
                active_table = filter(lambda table: table.offset == curr_row, current_tables)
                assert len(active_table) < 2
                if len(active_table) == 1:
                    if row == '':
                        current_tables.remove(active_table)
                    else:
                        curr_table = active_table
                        curr_table.col_heading = row
                        state = curr_table.type
                elif row <> '': # not in table => single entry or the beginning of a new table
                    curr_slot_num = get_slot_num(row)
                    if curr_slot_num == -1:
                        print 'unknown parameter ' + `row`
                        continue
                    if row.startswith('\\'):
                        curr_table = table.new(slot_num = curr_slot_num, offset = row, type = parent_to_child)
                        state = read_table_header
                    elif row.startswith('*'):
                        curr_table = table.new(slot_num = curr_slot_num, offset = row, type = multiply_numbers)
                        state = read_table_header
                    elif row.startswith('+'):
                        curr_table = table.new(slot_num = curr_slot_num, offset = row, type = concatenate_strings)
                        state = read_table_header
                    else:
                        curr_single_parameter = row
                        state = read_single_parameter
            elif state == states.read_table_header:
                if row <> '':
                    pass
                else:
                    pass
            elif state == states.read_parent_to_child_table:                
                assert(curr_table <> nil)
                if row <> '':
                    #TODO assert curr_row index of row_headings
                    first_level_slot_num = get_slot_num(row_headings[curr_row])
                    if first_level_slot_num == -1:
                        print 'unknown parameter ' + `row_headings[curr_row]`
                        continue
                    second_level_slot_num = get_slot_num(col_headings,first_level_slot_num)
                    if second_level_slot_num == -1:
                        print 'unknown parameter ' + `col_headings` + ' in ' + `row_headings[curr_row]`
                        continue
                    self[first_level_slot_num][second_level_slot_num] = row
                else:
                    current_tables.append(curr_table)
                    curr_table = nil
                    state = states.search
            elif state == states.read_multiply_numbers_table:
                pass
            elif state == states.read_concatenate_strings_table:
                pass
            elif state == states.read_single_parameter:
                pass
        return True
    
    def get_slot_num(self, slot_name, parent_slot_num):
        pass
